<template>
  <div class="app-container">
    <el-form
      ref="queryForm"
      :inline="true"
      :model="queryParams"
      label-width="68px"
    >
      <el-form-item label="用户名" prop="username">
        <el-input
          v-model="queryParams.username"
          clearable
          placeholder="请输入用户名"
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <!-- <el-form-item label="用户密码" prop="password">
        <el-input
          v-model="queryParams.password"
          placeholder="请输入用户密码"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="创建时间" prop="creatime">
        <el-input
          v-model="queryParams.creatime"
          placeholder="请输入创建时间"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="状态" prop="state">
        <el-input
          v-model="queryParams.state"
          placeholder="请输入状态"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="电话" prop="phone">
        <el-input
          v-model="queryParams.phone"
          placeholder="请输入电话"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="用户类别" prop="usertype">
        <el-input
          v-model="queryParams.usertype"
          placeholder="请输入用户类别"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item> -->
      <el-form-item>
        <el-button
          icon="el-icon-search"
          size="mini"
          type="primary"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置</el-button
        >
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['demo:user:add']"
          icon="el-icon-plus"
          size="mini"
          type="primary"
          @click="handleAdd"
          >新增</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['demo:user:edit']"
          :visible.sync="open"
          icon="el-icon-edit"
          size="mini"
          type="success"
          @click="userUpdate()"
          >修改</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['demo:user:remove']"
          :disabled="multiple"
          icon="el-icon-delete"
          size="mini"
          type="danger"
          @click="handleDelete"
          >删除</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['demo:user:export']"
          icon="el-icon-download"
          size="mini"
          type="warning"
          @click="handleExport"
          >导出</el-button
        >
      </el-col>
    </el-row>

    <el-table
      v-loading="loading"
      :data="userList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column align="center" type="selection" width="55" />
      <el-table-column align="center" label="用户名" prop="username" />
      <el-table-column align="center" label="用户密码" prop="password" />
      <el-table-column align="center" label="创建时间" prop="creatime" />
      <el-table-column align="center" label="状态" prop="state" />
      <el-table-column align="center" label="电话" prop="phone" />
      <el-table-column align="center" label="用户类别" prop="usertype" />
      <el-table-column
        align="center"
        class-name="small-padding fixed-width"
        label="操作"
      >
        <template slot-scope="scope">
          <el-button
            v-hasPermi="['demo:user:edit']"
            icon="el-icon-open"
            size="mini"
            type="text"
            @click="handleUpdate(scope.row)"
            >关联</el-button
          >
          <el-button
            v-hasPermi="['demo:user:remove']"
            icon="el-icon-delete"
            size="mini"
            type="text"
            @click="handleDelete(scope.row)"
            >删除</el-button>
          <el-button
            v-hasPermi="['demo:user:edit']"
            icon="el-icon-edit"
            size="mini"
            type="text"
            @click="UpdateById(scope.row)"
            >修改</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :limit.sync="queryParams.pageSize"
      :page.sync="queryParams.pageNum"
      :total="total"
      @pagination="getList"
    />

    <!-- 添加或修改用户对话框 -->
    <el-dialog
      :close-on-click-modal="false"
      :title="title"
      :visible.sync="open"
      width="500px"
    >
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="用户名" prop="username">
          <el-input v-model="form.username" placeholder="请输入用户名" />
        </el-form-item>
        <el-form-item label="用户密码" prop="password">
          <el-input v-model="form.password" placeholder="请输入用户密码" />
        </el-form-item>
        <!-- <el-form-item label="创建时间" prop="creatime">
          <el-input v-model="form.creatime" placeholder="请输入创建时间" />
        </el-form-item> -->
        <el-form-item label="状态" prop="state">
          <el-input v-model="form.state" placeholder="请输入状态" />
        </el-form-item>
        <el-form-item label="电话" prop="phone">
          <el-input v-model="form.phone" placeholder="请输入电话" />
        </el-form-item>
        <!-- <el-form-item label="用户类别" prop="usertype">
          <el-input v-model="form.usertype" placeholder="请输入用户类别" />
        </el-form-item> -->
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 添加或修改测试用户对话框 -->
    <el-dialog
      :close-on-click-modal="false"
      :destroy-on-close="true"
      :title="title"
      :visible.sync="open2"
      width="500px"
    >
      <div class="scroool">
        <el-tree
          ref="tree"
          :data="menuList"
          :default-checked-keys="defaultCheck"
          :expand-on-click-node="true"
          :filter-node-method="filterNode"
          :props="defaultProp"
          default-expand-all
          node-key="id"
          show-checkbox
        />
      </div>

      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="updateUserMenu()">确 定</el-button>
        <el-button type="danger" @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listUser,
  getUser,
  delUser,
  addUser,
  updateUser,
  exportUser,
} from "@/api/infomation/user";
import {
  listView,
  getView,
  delView,
  addView,
  updateView,
  exportView,
} from "@/api/infomation/view";
import {
  listUserView,
  getUserView,
  delUserView,
  addUserView,
  updateUserView,
  exportUserView,
  getUserMenu,
} from "@/api/infomation/userView";

export default {
  name: 'User',
  data() {
    return {
      // 遮罩层
      loading: true,
      userId: 0,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 总条数
      total: 0,
      // 用户表格数据
      userList: [],
      //查询详情表格数据
      menuList: [],
      defaultCheck: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      open2:false,
      // 类型数据字典
      statusOptions: [],
      // 状态数据字典
      typeOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        createBy: undefined,
        username: undefined,
        password: undefined,
        creatime: undefined,
        state: undefined,
        phone: undefined,
        usertype: undefined,
      },
      // 表单参数
      form: {},
      // 表单校验
      defaultProp: {
        label: "label",
      },
      // 表单校验
      rules: {
        xxx: [{ required: true, message: "xxx不能为空", trigger: "blur" }],
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询用户列表 */
    getList() {
      this.loading = true;
      listUser(this.queryParams).then((response) => {
        this.userList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 筛选节点
    filterNode(value, data) {
      if (!value) return true;
      return data.label.indexOf(value) !== -1;
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.open2 = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        username: undefined,
        password: undefined,
        creatime: undefined,
        state: undefined,
        phone: undefined,
        usertype: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length != 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加用户";
    },
    //修改用户信息
    UpdateById(row){
      this.reset();
      const id=row.id || this.ids
      getUser(id).then(response => {
          this.form=response.data;
          this.open=true;
          this.title="修改用户";
      })
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.userId = row.id; //获取菜单的id
      this.open2 = true;
      listView(this.queryParams).then((response) => {
        console.log("======获取菜单成功！=======");
        //数据处理
        var li = [];
        for (var i = 0; i < response.rows.length; i++) {
          var obj = {};
          obj.id = response.rows[i].id;
          obj.label = response.rows[i].viewName;
          li.push(obj);
        }
        this.menuList = li;
        console.log(li);
        this.total = response.total;
        this.loading = false;
      });
      //console.log(row);
      getUserMenu(row.id).then((response) => {
        console.log("=======根据用户id查询所有关联菜单的id=======");
        console.log(response);
        let arr = [];
        for (var i = 0; i < response.data.length; i++) {
          arr.push(response.data[i].viewId);
        }
        this.defaultCheck = arr;
        console.log(this.defaultCheck);
      });
    },
    updateUserMenu() {
      var that = this;
      console.log("嘿嘿我被执行了");
      const arr = that.$refs.tree
        .getCheckedKeys()
        .concat(that.$refs.tree.getHalfCheckedKeys());
      console.log("==============");
      console.log(arr);

      addUserView({ userID: that.userId, ids: arr }).then((response) => {
        console.log("=======对关联表做增加删除操作=======");
        console.log("=========" + response + "===============");
        this.defaultCheck = arr;
        this.open2 = false;
        this.$message({
          message: "修改成功！",
          type: "success",
        });
      });
    },
    userUpdate() {
      this.reset();
      this.open = true;
      this.title = "修改用户";
    },
    /** 提交按钮 */
    submitForm: function () {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != undefined) {
            updateUser(this.form).then((response) => {
              if (response.code === 200) {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              } else {
                this.msgError(response.msg);
              }
            });
          } else {
            addUser(this.form).then((response) => {
              if (response.code === 200) {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              } else {
                this.msgError(response.msg);
              }
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除id为"' + ids + '"的数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return delUser(ids);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
        .catch(function () {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有用户数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return exportUser(queryParams);
        })
        .then((response) => {
          this.download(response.msg);
        })
        .catch(function () {});
    },
  },
};
</script>
